local drawing, data, image, imgw, imgh, color

love.load = function ()
    --local flags = select(3, love.window.getMode())
    --love.window.setMode(1000, 500, flags)
    love.graphics.setBackgroundColor(255,255,255)
    love.graphics.setDefaultFilter("nearest","nearest")

    local drawings = require "drawings"

    imgw, imgh = 160, 144
    data = love.image.newImageData(imgw, imgh)
    image = love.graphics.newImage(data)
    
    color = {0,70,0}

    drawing = drawings.new(imgw, imgh)
end

love.update = function (dt)
    if love.keyboard.isDown("q") then
        drawing:rotate(dt)
    end
    if love.keyboard.isDown("e") then
        drawing:rotate(-dt)
    end
    if love.mouse.isDown("l") then
        local pxx, pxy = drawing:toWorld(love.mouse.getPosition())
        pxx, pxy = math.floor(pxx), math.floor(pxy)
        
        if pxx > 0 and pxx < imgw and pxy > 0 and pxy < imgh then
            data:setPixel(pxx, pxy, color[1], color[2], color[3], color[4])
            image = love.graphics.newImage(data) --DIRTY!!!
            collectgarbage() --Because we are doing something dirty up there
        end
    end
end

love.draw = function ()
    drawing:draw(image)
end

function love.mousepressed (x, y, button)
    if button == "wu" or button == "wd" then
        drawing:zoom(button == "wd" and "out" or "in", 2, x, y)
    end
end

function love.mousemoved (x, y, dx, dy)
    if love.mouse.isDown("r") then
        drawing:move(dx, dy)
    end
end

function love.keypressed (k)
    if k == "escape" then
        love.event.quit()
    elseif k == "r" then
        drawing:reset()
    elseif k == " " then
        data = love.image.newImageData(imgw, imgh)
        image = love.graphics.newImage(data) --DIRTY!!!
        collectgarbage() --Because we are doing something dirty up there
    end
end

function love.resize (w, h)
    drawing:setViewport(0, 0, w, h)
end